<?php

/*
*
*   Prune Alert
*   A Plugin for MyBB to display alert to the users who are under pruning criteria. 
*   http://demonate.com
*	effone@demonate.com
*
*/

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB")){
	die("Direct initialization of this file is not allowed.");
}

// Basic Informations about the plugin
function prunealert_info(){
	return array(
		'name'			=> 'Prune Alert',
		'description'	=> 'A Plugin for MyBB to display alert to the users who are under pruning criteria.',
		'website'		=> 'http://demonate.com',
		'author'		=> 'effone',
		'authorsite'	=> 'http://effone.in',
		'version'		=> '0.1',
		'guid' 			=> '616178affca38dbd3a8914326f7a7d00',
		'compatibility' => '16*'
	);
}

// Hooks :o
$plugins->add_hook('global_start', 'prunealert_show');

function prunealert_show(){
	global $db, $lang, $mybb, $templates, $prunealert, $prunealert_message;
	
	if($mybb->settings['enablepruning'] == 1 && $mybb->settings['prunealert_enable'] == 1){
	
		// If the account not activated & pruning activated
		if($mybb->settings['pruneunactived'] == 1 && $mybb->user['usergroup'] == '5'){ // Set the value to inactive usergroup
				$daysleft = floor($mybb->settings['dayspruneunactivated']-(intval(TIME_NOW-$mybb->user['regdate'])/24/60/60)+1);
				if ($daysleft > 0){ // This will bypass showing message to all the negative days left (if pruning activated later) as well as guests.
					if ($daysleft > 1){ $s1 = "s"; }
					$prunealert_message = $lang->sprintf($mybb->settings['prunealert_inactive_msg'],$daysleft,$s1);
					eval("\$prunealert = \"".$templates->get("prune_alert")."\";");
				}
		}
		// If the postcount is low, pruning activated against postcount and the user is not Admin, SMod, Mod or Banned
		else if ($mybb->settings['enableprunebyposts'] == 1 && $mybb->user['postnum'] <= $mybb->settings['prunepostcount'] && !$mybb->usergroup['isbannedgroup'] && !$mybb->usergroup['issupermod'] && !$mybb->usergroup['cancp'] && !$mybb->usergroup['canmodcp']){
				$requiredpost = $mybb->settings['prunepostcount']-$mybb->user['postnum']+1;
				$daysleft = floor($mybb->settings['dayspruneregistered']-(intval(TIME_NOW-$mybb->user['regdate'])/24/60/60)+1);
				if ($daysleft > 0){
					if ($daysleft > 1){ $s1 = "s"; }
					if ($requiredpost > 1){ $s2 = "s"; }
					$prunealert_message = $lang->sprintf($mybb->settings['prunealert_lowpost_msg'],$daysleft,$s1,$requiredpost,$s2);
					eval("\$prunealert = \"".$templates->get("prune_alert")."\";");
				}
		}
	}
}

function prunealert_activate(){
	require_once MYBB_ROOT."/inc/adminfunctions_templates.php";
	
	global $db, $mybb, $lang;
	$lang->load("prunealert");
	
	// Create the template for Message
	$template = array(
		"title"		=> "prune_alert",
		"template"	=> '<div class="red_alert"><strong>{$prunealert_message}</strong></div><br />',
		"sid"		=> -1
	);
	$db->insert_query("templates", $template);
	
	// Insert alert message variable in theme templates
	find_replace_templatesets('header', '#{\$pm_notice}#', '{\$prunealert}{\$pm_notice}');
	
	// Build Plugin Settings
	$prunealert_group = array(
		"name"			=> "prunealert",
		"title"			=> "Prune Alert",
		"description"	=> "A Plugin for MyBB to display alert to the users who are under pruning criteria.",
		"disporder"		=> "9",
		"isdefault"		=> "0"
	);	
	$db->insert_query("settinggroups", $prunealert_group);
	$gid = $db->insert_id();
	
	$prunealert[] = array(
		"name"			=> "prunealert_enable",
		"title"			=> $lang->prunealert_elable,
		"description"	=> $lang->prunealert_elable_desc,
		"optionscode" 	=> "onoff",
		"value"			=> '1',
		"disporder"		=> '1',
		"gid"			=> intval($gid),
	);
	
	$prunealert[] = array(
		"name"			=> "prunealert_inactive_enable",
		"title"			=> $lang->prunealert_inactive_elable,
		"description"	=> $lang->prunealert_inactive_elable_desc,
		"optionscode" 	=> "onoff",
		"value"			=> '1',
		"disporder"		=> '2',
		"gid"			=> intval($gid),
	);
	
	$prunealert[]= array(
		"name"			=> "prunealert_inactive_msg",
		"title"			=> $lang->prunealert_inactive_msg,
		"description"	=> $lang->prunealert_inactive_msg_desc,
		"optionscode" 	=> 'textarea',
		"value"			=> 'You have not been activated your account yet. If you do not activate within {1} day{2} your account will be deleted from this site.',
		"disporder"		=> '3',
		"gid"			=> intval($gid),
	);
	
	$prunealert[] = array(
		"name"			=> "prunealert_lowpost_enable",
		"title"			=> $lang->prunealert_lowpost_elable,
		"description"	=> $lang->prunealert_lowpost_elable_desc,
		"optionscode" 	=> "onoff",
		"value"			=> '1',
		"disporder"		=> '4',
		"gid"			=> intval($gid),
	);
	
	$prunealert[]= array(
		"name"			=> "prunealert_lowpost_msg",
		"title"			=> $lang->prunealert_lowpost_msg,
		"description"	=> $lang->prunealert_lowpost_msg_desc,
		"optionscode" 	=> 'textarea',
		"value"			=> 'Your account will be deleted in {1} day{2} if you do not make {3} more post{4}.',
		"disporder"		=> '5',
		"gid"			=> intval($gid),
	);
	
	foreach($prunealert as $prunealertopts)
	{
		$db->insert_query("settings", $prunealertopts);
	}
	
	rebuild_settings();
}

function prunealert_deactivate(){
    require_once MYBB_ROOT.'/inc/adminfunctions_templates.php';
	
	global $db, $mybb;
	$db->delete_query("settings", "name IN ('prunealert_enable', 'prunealert_inactive_enable', 'prunealert_inactive_msg', 'prunealert_lowpost_enable', 'prunealert_lowpost_msg')");
	$db->delete_query("settinggroups", "name='prunealert'");
	
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='prune_alert'");
	find_replace_templatesets('header', '#\{\$prunealert}#is', '', 0);
    rebuild_settings();
}

?>